#!/usr/bin/env node

var ShExLoader = require("./lib/ShExLoader"); // for verbose output
var Mapper = require("./extensions/shex-map");

require("promise").all([ShExLoader.load(["test/Map/BPFHIR.shex"], [], ["test/Map/BPFHIR.ttl"]),
             ShExLoader.load(["test/Map/BPunitsDAM.shex"], [], [])]).
  then(function (loads) {
    var validator = require("./lib/ShExValidator")(loads[0].schema);
    var map = Mapper.materializer(loads[1].schema);
    Mapper.register(validator);
    var res = validator.validate(loads[0].data, "tag:BPfhir123", null);
    var outputGraph = map.materialize(validator.semActHandler.results["http://shex.io/extensions/Map/#"], "tag:b0");
  });
